/******************************************************************************************************************************************
   Tracker3.c - Sun Position Locator

   Date: March 2015

   Configuration:
       MCU:                STM32F415RG
       Development Board:  Mini-M4 for STM32
       Crystal Oscillator: 16 MHz
       System Clock:       120 MHz
       Compiler:           mikroC PRO for ARM
       Program Loader:     USB_HID Bootloader
       Power:              USB cable

//*****************************************************************************************************************************************
       Note1: In Edit Project panel Data Type Size set to other (int 4 byte)
       Note2: In Tools, Options, Output Tab, Optimization Level has to be set to Zero. Otherwise, compiled code will hang up.
       Note3: Long double precision is required for calculations. It would be nice if Edit Project panel had a similar pull-down
              box to set double as 8 bytes.

*/


#include "USB_Driver.h"



void main() {

     USB_Init();                   // Initialize USB

     EnableInterrupts();           // Enable interrupts

     while(1) {

          USB_CheckIn();           // Check for incoming USB messages
          USB_CheckOut();          // Check for outgoing USB messages
     }
}