#line 1 "C:/ARM Projects/MINI-M4 for STM32/SolarTrackerTry3/USB_Driver.c"
#line 1 "c:/arm projects/mini-m4 for stm32/solartrackertry3/usb_driver.h"
#line 11 "c:/arm projects/mini-m4 for stm32/solartrackertry3/usb_driver.h"
typedef char *pnt;


typedef struct USB_TxStruct {
 unsigned int in;
 unsigned int out;
 pnt q[ 64 ];
}USB_TxStruct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 1 "c:/arm projects/mini-m4 for stm32/solartrackertry3/buffers.h"
#line 13 "c:/arm projects/mini-m4 for stm32/solartrackertry3/buffers.h"
char* GetBuffer(void);
#line 1 "c:/arm projects/mini-m4 for stm32/solartrackertry3/spa.h"
#line 63 "c:/arm projects/mini-m4 for stm32/solartrackertry3/spa.h"
enum {
 SPA_ZA,
 SPA_ZA_INC,
 SPA_ZA_RTS,
 SPA_ALL,
};

typedef struct
{


 int year;
 int month;
 int day;
 int hour;
 int minute;
 long double second;

 long double delta_ut1;






 long double delta_t;





 long double timezone;


 long double longitude;


 long double latitude;


 long double elevation;


 long double pressure;


 long double temperature;


 long double slope;


 long double azm_rotation;



 long double atmos_refract;


 int function;



 long double jd;
 long double jc;

 long double jde;
 long double jce;
 long double jme;

 long double l;
 long double b;
 long double r;

 long double theta;
 long double beta;

 long double x0;
 long double x1;
 long double x2;
 long double x3;
 long double x4;

 long double del_psi;
 long double del_epsilon;
 long double epsilon0;
 long double epsilon;

 long double del_tau;
 long double lamda;
 long double nu0;
 long double nu;

 long double alpha;
 long double delta;

 long double h;
 long double xi;
 long double del_alpha;
 long double delta_prime;
 long double alpha_prime;
 long double h_prime;

 long double e0;
 long double del_e;
 long double e;

 long double eot;
 long double srha;
 long double ssha;
 long double sta;



 long double zenith;
 long double azimuth_astro;
 long double azimuth;
 long double incidence;

 long double suntransit;
 long double sunrise;
 long double sunset;

} spa_data;



long double deg2rad(long double degrees);
long double rad2deg(long double radians);
long double deg2rad(long double degrees);
int integer(long double value);
long double limit_degrees(long double degrees);
long double limit_degrees180pm(long double degrees);
long double limit_degrees180(long double degrees);
long double limit_zero2one(long double value);
long double limit_minutes(long double minutes);
long double dayfrac_to_local_hr(long double dayfrac, long double timezone);
long double third_order_polynomial(long double a, long double b, long double c, long double d, long double x);

int validate_inputs(spa_data *spa);
long double julian_day (int year, int month, int day, int hour, int minute, long double second,
 long double dut1, long double tz);

long double julian_century(long double jd);
long double julian_ephemeris_day(long double jd, long double delta_t);
long double julian_ephemeris_century(long double jde);
long double julian_ephemeris_millennium(long double jce);

long double earth_periodic_term_summation(const long double terms[][3], int count, long double jme);


long double earth_values(long double term_sum[], int count, long double jme);
long double earth_heliocentric_longitude(long double jme);
long double earth_heliocentric_latitude(long double jme);
long double earth_radius_vector(long double jme);
long double geocentric_longitude(long double l);
long double geocentric_latitude(long double b);
long double mean_elongation_moon_sun(long double jce);
long double mean_anomaly_sun(long double jce);
long double mean_anomaly_moon(long double jce);
long double argument_latitude_moon(long double jce);
long double ascending_longitude_moon(long double jce);



void nutation_longitude_and_obliquity(long double jce, long double x[5], long double *del_psi, long double *del_epsilon);
long double ecliptic_mean_obliquity(long double jme);
long double ecliptic_true_obliquity(long double delta_epsilon, long double epsilon0);
long double aberration_correction(long double r);
long double apparent_sun_longitude(long double theta, long double delta_psi, long double delta_tau);
long double greenwich_mean_sidereal_time (long double jd, long double jc);
long double greenwich_sidereal_time (long double nu0, long double delta_psi, long double epsilon);
long double geocentric_right_ascension(long double lamda, long double epsilon, long double beta);
long double geocentric_declination(long double beta, long double epsilon, long double lamda);
long double observer_hour_angle(long double nu, long double longitude, long double alpha_deg);
long double sun_equatorial_horizontal_parallax(long double r);
void right_ascension_parallax_and_topocentric_dec(long double latitude, long double elevation, long double xi, long double h,
 long double delta, long double *delta_alpha, long double *delta_prime);
long double topocentric_right_ascension(long double alpha_deg, long double delta_alpha);
long double topocentric_local_hour_angle(long double h, long double delta_alpha);
long double topocentric_elevation_angle(long double latitude, long double delta_prime, long double h_prime);
long double atmospheric_refraction_correction(long double pressure, long double temperature, long double atmos_refract, long double e0);
long double topocentric_elevation_angle_corrected(long double e0, long double delta_e);
long double topocentric_zenith_angle(long double e);
long double topocentric_azimuth_angle_astro(long double h_prime, long double latitude, long double delta_prime);
long double topocentric_azimuth_angle(long double azimuth_astro);
long double sun_mean_longitude(long double jme);
long double eot(long double m, long double alpha, long double del_psi, long double epsilon);
long double approx_sun_transit_time(long double alpha_zero, long double longitude, long double nu);
long double sun_hour_angle_at_rise_set(long double latitude, long double delta_zero, long double h0_prime);
void approx_sun_rise_and_set(long double *m_rts, long double h0);
long double rts_alpha_delta_prime(long double *ad, long double n);
long double rts_sun_altitude(long double latitude, long double delta_prime, long double h_prime);
long double sun_rise_and_set(long double *m_rts, long double *h_rts, long double *delta_prime, long double latitude, long double *h_prime,
 long double h0_prime, int sun);

void calculate_geocentric_sun_right_ascension_and_declination(spa_data *spa);
void calculate_eot_and_sun_rise_transit_set(spa_data *spa);



int spa_calculate(spa_data *spa);





void SPA_Test(void);


void MyTest2(void);
#line 12 "C:/ARM Projects/MINI-M4 for STM32/SolarTrackerTry3/USB_Driver.c"
char readbuff[64];
char writebuff[64];

USB_TxStruct USB_Queue;
#line 22 "C:/ARM Projects/MINI-M4 for STM32/SolarTrackerTry3/USB_Driver.c"
void USBInterrupt() iv IVT_INT_OTG_FS ics ICS_AUTO {
 USB_Interrupt_Proc();
}
#line 28 "C:/ARM Projects/MINI-M4 for STM32/SolarTrackerTry3/USB_Driver.c"
void USB_Init(void) {



 HID_Enable(&readbuff,&writebuff);
 USB_TxQueueInit();

}
#line 39 "C:/ARM Projects/MINI-M4 for STM32/SolarTrackerTry3/USB_Driver.c"
void USB_TxQueueInit(void) {
 USB_Queue.in = 0;
 USB_Queue.out = 0;
}
#line 47 "C:/ARM Projects/MINI-M4 for STM32/SolarTrackerTry3/USB_Driver.c"
void USB_PutQueue(char *msg) {
 USB_Queue.q[USB_Queue.in++] = msg;
 if (USB_Queue.in > ( 64 -1))
 USB_Queue.in = 0;
}
#line 59 "C:/ARM Projects/MINI-M4 for STM32/SolarTrackerTry3/USB_Driver.c"
void USB_CheckOut(void) {


 if (USB_Queue.in != USB_Queue.out) {

 if (HID_Write(USB_Queue.q[USB_Queue.out],64) != 0) {
 USB_Queue.out++;
 if (USB_Queue.out > ( 64 -1))
 USB_Queue.out = 0;
 }
 }
}
#line 76 "C:/ARM Projects/MINI-M4 for STM32/SolarTrackerTry3/USB_Driver.c"
void USB_CheckIn(void) {
 char *BufNum;
 double Temp1;

 if (HID_Read() != 0) {
 switch (readbuff[0]) {

 case 'a':
 BufNum = GetBuffer();
 sprintf(BufNum,"Command a received\r\n");
 USB_PutQueue(BufNum);
 break;
 case 'b':
 Temp1 = atan2(2., 1.);
 BufNum = GetBuffer();
 FloatToStr(Temp1,BufNum);
 strcat(BufNum,"\r\n");
 USB_PutQueue(BufNum);

 break;
 case 'c':
 MyTest2();
 USB_PutQueue("Done\r\n");
 break;
 case 'd':
 break;
 case 'e':
 break;
 case 'f':
 break;
 case 'g':
 break;
 case 'h':
 break;
 case 'i':
 break;
 case 'j':
 break;
 case 'k':
 break;
 case 'l':
 break;
 case 'm':
 break;
 case 'n':
 break;
 case 'o':
 break;
 case 'p':
 break;
 case 'q':
 break;
 case 'r':
 break;
 case 's':
 SPA_Test();
 break;
 case 't':
 break;
 case 'u':
 break;
 case 'v':
 break;
 case 'w':
 break;
 case 'x':
 break;
 case 'y':
 break;
 case 'z':
 break;



 default:
 USB_PutQueue("Unknown command\r\n");

 BufNum = GetBuffer();
 (void)sprintf(BufNum,"%c\r\n",readbuff[0]);
 USB_PutQueue(BufNum);
 break;
 }
 }
}
