#line 1 "C:/ARM Projects/MINI-M4 for STM32/SolarTrackerTry3/spa_tester.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdio.h"
#line 1 "c:/arm projects/mini-m4 for stm32/solartrackertry3/spa.h"
#line 63 "c:/arm projects/mini-m4 for stm32/solartrackertry3/spa.h"
enum {
 SPA_ZA,
 SPA_ZA_INC,
 SPA_ZA_RTS,
 SPA_ALL,
};

typedef struct
{


 int year;
 int month;
 int day;
 int hour;
 int minute;
 long double second;

 long double delta_ut1;






 long double delta_t;





 long double timezone;


 long double longitude;


 long double latitude;


 long double elevation;


 long double pressure;


 long double temperature;


 long double slope;


 long double azm_rotation;



 long double atmos_refract;


 int function;



 long double jd;
 long double jc;

 long double jde;
 long double jce;
 long double jme;

 long double l;
 long double b;
 long double r;

 long double theta;
 long double beta;

 long double x0;
 long double x1;
 long double x2;
 long double x3;
 long double x4;

 long double del_psi;
 long double del_epsilon;
 long double epsilon0;
 long double epsilon;

 long double del_tau;
 long double lamda;
 long double nu0;
 long double nu;

 long double alpha;
 long double delta;

 long double h;
 long double xi;
 long double del_alpha;
 long double delta_prime;
 long double alpha_prime;
 long double h_prime;

 long double e0;
 long double del_e;
 long double e;

 long double eot;
 long double srha;
 long double ssha;
 long double sta;



 long double zenith;
 long double azimuth_astro;
 long double azimuth;
 long double incidence;

 long double suntransit;
 long double sunrise;
 long double sunset;

} spa_data;



long double deg2rad(long double degrees);
long double rad2deg(long double radians);
long double deg2rad(long double degrees);
int integer(long double value);
long double limit_degrees(long double degrees);
long double limit_degrees180pm(long double degrees);
long double limit_degrees180(long double degrees);
long double limit_zero2one(long double value);
long double limit_minutes(long double minutes);
long double dayfrac_to_local_hr(long double dayfrac, long double timezone);
long double third_order_polynomial(long double a, long double b, long double c, long double d, long double x);

int validate_inputs(spa_data *spa);
long double julian_day (int year, int month, int day, int hour, int minute, long double second,
 long double dut1, long double tz);

long double julian_century(long double jd);
long double julian_ephemeris_day(long double jd, long double delta_t);
long double julian_ephemeris_century(long double jde);
long double julian_ephemeris_millennium(long double jce);

long double earth_periodic_term_summation(const long double terms[][3], int count, long double jme);


long double earth_values(long double term_sum[], int count, long double jme);
long double earth_heliocentric_longitude(long double jme);
long double earth_heliocentric_latitude(long double jme);
long double earth_radius_vector(long double jme);
long double geocentric_longitude(long double l);
long double geocentric_latitude(long double b);
long double mean_elongation_moon_sun(long double jce);
long double mean_anomaly_sun(long double jce);
long double mean_anomaly_moon(long double jce);
long double argument_latitude_moon(long double jce);
long double ascending_longitude_moon(long double jce);



void nutation_longitude_and_obliquity(long double jce, long double x[5], long double *del_psi, long double *del_epsilon);
long double ecliptic_mean_obliquity(long double jme);
long double ecliptic_true_obliquity(long double delta_epsilon, long double epsilon0);
long double aberration_correction(long double r);
long double apparent_sun_longitude(long double theta, long double delta_psi, long double delta_tau);
long double greenwich_mean_sidereal_time (long double jd, long double jc);
long double greenwich_sidereal_time (long double nu0, long double delta_psi, long double epsilon);
long double geocentric_right_ascension(long double lamda, long double epsilon, long double beta);
long double geocentric_declination(long double beta, long double epsilon, long double lamda);
long double observer_hour_angle(long double nu, long double longitude, long double alpha_deg);
long double sun_equatorial_horizontal_parallax(long double r);
void right_ascension_parallax_and_topocentric_dec(long double latitude, long double elevation, long double xi, long double h,
 long double delta, long double *delta_alpha, long double *delta_prime);
long double topocentric_right_ascension(long double alpha_deg, long double delta_alpha);
long double topocentric_local_hour_angle(long double h, long double delta_alpha);
long double topocentric_elevation_angle(long double latitude, long double delta_prime, long double h_prime);
long double atmospheric_refraction_correction(long double pressure, long double temperature, long double atmos_refract, long double e0);
long double topocentric_elevation_angle_corrected(long double e0, long double delta_e);
long double topocentric_zenith_angle(long double e);
long double topocentric_azimuth_angle_astro(long double h_prime, long double latitude, long double delta_prime);
long double topocentric_azimuth_angle(long double azimuth_astro);
long double sun_mean_longitude(long double jme);
long double eot(long double m, long double alpha, long double del_psi, long double epsilon);
long double approx_sun_transit_time(long double alpha_zero, long double longitude, long double nu);
long double sun_hour_angle_at_rise_set(long double latitude, long double delta_zero, long double h0_prime);
void approx_sun_rise_and_set(long double *m_rts, long double h0);
long double rts_alpha_delta_prime(long double *ad, long double n);
long double rts_sun_altitude(long double latitude, long double delta_prime, long double h_prime);
long double sun_rise_and_set(long double *m_rts, long double *h_rts, long double *delta_prime, long double latitude, long double *h_prime,
 long double h0_prime, int sun);

void calculate_geocentric_sun_right_ascension_and_declination(spa_data *spa);
void calculate_eot_and_sun_rise_transit_set(spa_data *spa);



int spa_calculate(spa_data *spa);





void SPA_Test(void);


void MyTest2(void);
#line 1 "c:/arm projects/mini-m4 for stm32/solartrackertry3/buffers.h"
#line 13 "c:/arm projects/mini-m4 for stm32/solartrackertry3/buffers.h"
char* GetBuffer(void);
#line 1 "c:/arm projects/mini-m4 for stm32/solartrackertry3/usb_driver.h"
#line 11 "c:/arm projects/mini-m4 for stm32/solartrackertry3/usb_driver.h"
typedef char *pnt;


typedef struct USB_TxStruct {
 unsigned int in;
 unsigned int out;
 pnt q[ 64 ];
}USB_TxStruct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 41 "C:/ARM Projects/MINI-M4 for STM32/SolarTrackerTry3/spa_tester.c"
spa_data spa;



void SPA_Test(void)
{

 int result;
 int hrs, min, sec;
 char* BufNum;
 char Code;
 char FormatBuf[64];
 long double a;


 spa.year = 2003;
 spa.month = 10;
 spa.day = 17;
 spa.hour = 12;
 spa.minute = 30;
 spa.second = 30;
 spa.delta_ut1 = 0;
 spa.delta_t = 67;
 spa.timezone = -7.0;
 spa.longitude = -105.1786;
 spa.latitude = 39.742476;
 spa.elevation = 1830.14;
 spa.pressure = 820;
 spa.temperature = 11;
 spa.slope = 30;
 spa.azm_rotation = -10;
 spa.atmos_refract = 0.5667;
 spa.function = SPA_ALL;




 result = spa_calculate(&spa);

 if (result == 0)
 {

 USB_PutQueue("\r\n");

 BufNum = GetBuffer();
 Code = LongDoubleToStr(spa.jd, FormatBuf);
 (void)sprintf(BufNum,"Julian Day:    ");
 strcat(BufNum,FormatBuf);
 strcat(BufNum,"\r\n");
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 Code = LongDoubleToStr(spa.l, FormatBuf);
 (void)sprintf(BufNum,"L:             ");
 strcat(BufNum,FormatBuf);
 strcat(BufNum," degrees\r\n");
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 Code = LongDoubleToStr(spa.b, FormatBuf);
 (void)sprintf(BufNum,"B:             ");
 strcat(BufNum,FormatBuf);
 strcat(BufNum," degrees\r\n");
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 Code = LongDoubleToStr(spa.r, FormatBuf);
 (void)sprintf(BufNum,"R:             ");
 strcat(BufNum,FormatBuf);
 strcat(BufNum," AU\r\n");
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 Code = LongDoubleToStr(spa.h, FormatBuf);
 (void)sprintf(BufNum,"H:             ");
 strcat(BufNum,FormatBuf);
 strcat(BufNum," degrees\r\n");
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 Code = LongDoubleToStr(spa.del_psi, FormatBuf);
 (void)sprintf(BufNum,"Delta Psi:     ");
 strcat(BufNum,FormatBuf);
 strcat(BufNum," degrees\r\n");
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 Code = LongDoubleToStr(spa.del_epsilon, FormatBuf);
 (void)sprintf(BufNum,"Delta Epsilon: ");
 strcat(BufNum,FormatBuf);
 strcat(BufNum," degrees\r\n");
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 Code = LongDoubleToStr(spa.epsilon, FormatBuf);
 (void)sprintf(BufNum,"Epsilon:       ");
 strcat(BufNum,FormatBuf);
 strcat(BufNum," degrees\r\n");
 USB_PutQueue(BufNum);

 USB_PutQueue("\r\n");

 BufNum = GetBuffer();
 Code = LongDoubleToStr(spa.zenith, FormatBuf);
 (void)sprintf(BufNum,"Zenith:        ");
 strcat(BufNum,FormatBuf);
 strcat(BufNum," degrees\r\n");
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 Code = LongDoubleToStr(spa.azimuth_astro, FormatBuf);
 (void)sprintf(BufNum,"Azimuth_astro: ");
 strcat(BufNum,FormatBuf);
 strcat(BufNum," degrees\r\n");
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 Code = LongDoubleToStr(spa.azimuth, FormatBuf);
 (void)sprintf(BufNum,"Azimuth:       ");
 strcat(BufNum,FormatBuf);
 strcat(BufNum," degrees\r\n");
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 Code = LongDoubleToStr(spa.incidence, FormatBuf);
 (void)sprintf(BufNum,"Incidence:     ");
 strcat(BufNum,FormatBuf);
 strcat(BufNum," degrees\r\n");
 USB_PutQueue(BufNum);

 USB_PutQueue("\r\n");

 hrs = (int)(spa.sunrise);
 a = 60.0L * (spa.sunrise - hrs);
 min = (int)(a);
 a = 60.0L * (a - min);
 sec = (int)(a);
 BufNum = GetBuffer();
 (void)sprintf(BufNum,"Sunrise:       %02d:%02d:%02d Local Time\r\n", hrs, min, sec);
 USB_PutQueue(BufNum);

 hrs = (int)(spa.suntransit);
 a = 60.0L * (spa.suntransit - hrs);
 min = (int)(a);
 a = 60.0L * (a - min);
 sec = (int)(a);
 BufNum = GetBuffer();
 (void)sprintf(BufNum,"Suntransit:    %02d:%02d:%02d Local Time\r\n", hrs, min, sec);
 USB_PutQueue(BufNum);

 hrs = (int)(spa.sunset);
 a = 60.0L * (spa.sunset - hrs);
 min = (int)(a);
 a = 60.0L * (a - min);
 sec = (int)(a);
 BufNum = GetBuffer();
 (void)sprintf(BufNum,"Sunset:        %02d:%02d:%02d Local Time\r\n", hrs, min, sec);
 USB_PutQueue(BufNum);

 USB_PutQueue("\r\n");

 BufNum = GetBuffer();
 Code = LongDoubleToStr(spa.azimuth - 180.0L, FormatBuf);
 (void)sprintf(BufNum,"Pan angle from South:       ");
 strcat(BufNum,FormatBuf);
 strcat(BufNum," degrees\r\n");
 USB_PutQueue(BufNum);

 BufNum = GetBuffer();
 Code = LongDoubleToStr(90.0L - spa.zenith, FormatBuf);
 (void)sprintf(BufNum,"Tilt angle from horizontal: ");
 strcat(BufNum,FormatBuf);
 strcat(BufNum," degrees\r\n");
 USB_PutQueue(BufNum);
 }
 else
 {
 BufNum = GetBuffer();
 (void)sprintf(BufNum,"SPA Error Code: %d\r\n", result);
 USB_PutQueue(BufNum);
 }
}
